export declare type XHRData = ArrayBufferView | Blob | Document | string | FormData;
export interface ResponsePackage<T> {
    parsedResponse: T;
    request: XMLHttpRequest;
}
/**
* Base communication layer for talking to the OneNote APIs.
*/
export declare class OneNoteApiBase {
    useBetaApi: boolean;
    private authHeader;
    private timeout;
    private headers;
    private oneNoteApiHostOverride;
    private queryParams;
    constructor(authHeader: string, timeout: number, headers?: {
        [key: string]: string;
    }, oneNoteApiHostOverride?: string, queryParams?: {
        [key: string]: string;
    });
    protected requestPromise(url: string, data?: XHRData, contentType?: string, httpMethod?: string, isFullUrl?: boolean, urlContainsVersion?: boolean): Promise<ResponsePackage<any>>;
    private appendQueryParams;
    private generateUrlUntilVersion;
    generateFullUrl(partialUrl: string, urlContainsVersion?: boolean): string;
    generateFullMeNotesUrl(partialUrl: string, urlContainsVersion?: boolean): string;
    private makeRequest;
    private static addHeadersToRequest;
}
